/****************************************************************************
*                                                                           *
*     ______     ______     __   __     ______     __  __     ______        *
*    /\___  \   /\___  \   /\ "-.\ \   /\  __ \   /\ \/ /    /\  ___\       *
*    \/_/  /__  \/_/  /__  \ \ \-.  \  \ \  __ \  \ \  _"-.  \ \  __\       *
*      /\_____\   /\_____\  \ \_\\"\_\  \ \_\ \_\  \ \_\ \_\  \ \_____\     *
*      \/_____/   \/_____/   \/_/ \/_/   \/_/\/_/   \/_/\/_/   \/_____/     *
*                                                                           *
*                                                                           *
*                                                                           *
*   This file is part of zZNAKE                                             *
*                                                                           *
*   Copyright (C) 2012  Fabien LOISON <http://www.flogisoft.com>            *
*                                                                           *
*   zZNAKE is free software: you can redistribute it and/or modify          *
*   it under the terms of the GNU General Public License as published by    *
*   the Free Software Foundation, either version 3 of the License, or       *
*   (at your option) any later version.                                     *
*                                                                           *
*   This program is distributed in the hope that it will be useful,         *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
*   GNU General Public License for more details.                            *
*                                                                           *
*   You should have received a copy of the GNU General Public License       *
*   along with this program.  If not, see <http://www.gnu.org/licenses/>.   *
*                                                                           *
****************************************************************************/


#define SNK_MAX_LENGTH 40

#define DIRECTION_UP    0
#define DIRECTION_RIGHT 1
#define DIRECTION_DOWN  2
#define DIRECTION_LEFT  3

struct SnakeBody
{
	int x;
	int y;
	int alive;
};
typedef struct SnakeBody SnakeBody;


struct Game
{
	int level;
	int speed;
	unsigned char map[LEVEL_SIZE];
	SnakeBody snake[SNK_MAX_LENGTH];
	int direction;
};
typedef struct Game Game;


void game_new();
void game_load_level(Game *game, int level);
void game_refresh(Game *game);
void game_move_snake(Game *game);

void map_set_xy(Game *game, int x, int y, unsigned char tile);
